; Mr Proxy 2.0
; Pasmal <pasmal@zaz.net>
; http://helpdesk.zaz.net/

menu menubar,status {
  Mr &Proxy 2.0
  .&Settings...: dialog -mdo proxy proxy
  .-
  . $iif($isfile(proxy-help.txt) == $true,&Help,Help File Missing!) : if ($isfile(proxy-help.txt)) { dialog -mdo proxy proxy | .timer -m 1 1 loadbuf -o proxy 60 proxy-help.txt | set %proxy.last.tab 5 | .timer -m 1 1 did -f proxy 5 | .timer -m 1 1 did -h proxy 200 } | else { echo 4 -a *** Proxy-Help.txt is missing. It should be located in the Mr Proxy 2.0 zip file. }
  .&Unload: UNLOAD-proxy
}
;------ Aliases ------
alias UNLOAD-proxy {
  if ($$?!="Are you sure you want to unload Mr Proxy 2.0?" == $true) {
    .remove $scriptdirproxy.dat
    unset -s %proxy.*
    .timer 1 1 unload -rs $script
    echo 3 -a *** Mr Proxy 2.0 unload (not delete) has been a success... Unloading final file now:
  }
}
;-------------------- Sockmark editing and viewing aliases
alias -l ssock {
  if ($isid == $true) && ($sock($1) != $null) { 
    ;    echo -s gsock 6: $gsock($1,6)
    return $calc($ctime - $gsock($1,6))
  }
}
alias -l gsock {
  ; $gsock(sockname,N)
  if ($sock($1).ip != $null) && ($2 != $null) {
    return $gettok($sock($1).mark,$2,46)
  }
  return
}
alias -l rsock {
  ;/rsock sockname N new-value
  ;username.nickname.server.port.check
  if ($sock($1).ip != $null) && ($3 != $null) {
    sockmark $1 $puttok($sock($1).mark,$3-,$2,46)
  }
}
;-------------------- End of Sockmark editing and viewing ailases
alias -l proxy.connect {
  if ($3) {
    if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) Attempting to connect $sock($1).ip ( $+ $gsock($1,2) $+ ) to $2-
    sockwrite -n $1 Connecting to $2-
    sockopen b $+ $1 $2 $iif($3 == $null,6667,$3)
    rsock $1 3 $replace($2,$chr(46),$chr(1))
    rsock $1 4 $iif($3 == $null,6667,$3)
  }
}
alias proxy.check.idle {
  if (%proxy.settings.idlekick == 1) && (%proxy.settings.idlekick.duration isnum) {
    var %proxy.check.idle.total = $sock(pxy*,0)
    var %proxy.check.idle.count 0
    :start
    inc %proxy.check.idle.count
    if ($ssock($sock(pxy*,%proxy.check.idle.count)) >= %proxy.settings.idlekick.duration) { sockwrite -n $sock(pxy*,%proxy.check.idle.count).name Disconnecting you because you have been idle $duration($ssock($sock(pxy*,%proxy.check.idle.count))) $+ , the limit is $duration(%proxy.settings.idlekick.duration) | .timer 1 1 sockclose $sock(pxy*,%proxy.check.idle.count) }
    ; if ($sock(pxy*,%proxy.check.idle.count).ls >= %proxy.settings.idlekick.duration) { sockwrite -n $sock(pxy*,%proxy.check.idle.count).name Disconnecting you because you have been idle $duration($sock(pxy*,%proxy.check.idle.count).ls) $+ , the limit is $duration(%proxy.settings.idlekick.duration) | .timer 1 1 sockclose $sock(pxy*,%proxy.check.idle.count) }
    if (%proxy.check.idle.count < %proxy.check.idle.total) goto start
    proxy.update.tab4
  }
}
alias proxy.settings dialog -mdo proxy proxy
alias -l proxy.update.tab2 {
  if ($dialog(proxy) == $null) return
  if (%proxy.settings.ports) { did -r proxy 8 | did -a proxy 8 %proxy.settings.ports }
  if (%proxy.settings.identd) { did -r proxy 214 | did -a proxy 214 %proxy.settings.identd }
  if (%proxy.settings.connect.server) { did -r proxy 18 | did -a proxy 18 %proxy.settings.connect.server }
  if (%proxy.settings.idlekick.cline) did -c proxy 21 %proxy.settings.idlekick.cline
  if (%proxy.settings.limit.number) did -c proxy 13 %proxy.settings.limit.number
  if (%proxy.settings.enable) did -c proxy 6
  if (%proxy.settings.guest) did -c proxy 10
  if (%proxy.settings.ping) did -c proxy 11
  if (%proxy.settings.limit) did -c proxy 12
  if (%proxy.settings.motd) did -c proxy 14
  if (%proxy.settings.connect == 1) did -c proxy 17
  if (%proxy.settings.connect == 0) did -c proxy 19
  if (%proxy.settings.idlekick) did -c proxy 20
  if (%proxy.settings.motd.file) { did -r proxy 15 | did -a proxy 15 $nopath(%proxy.settings.motd.file) }
  if (%proxy.settings.log) did -c proxy 212
  if ($group(#proxy.identserver)) did -c proxy 213
}
alias -l proxy.retype.userlist {
  if ($dialog(proxy) == $null) return
  did -r proxy 24
  var %proxy.temp.1 = 1
  var %proxy.temp.2 = $lines($scriptdirproxy.dat)
  if (%proxy.temp.2 > 0) {
    :start.2
    inc %proxy.temp.1
    var %proxy.temp.3 = $read -nl [ $+ [ %proxy.temp.1 ] ] $scriptdirproxy.dat 
    var %proxy.temp.3 = $gettok(%proxy.temp.3,1,61)
    did -a proxy 24 %proxy.temp.3
    if (%proxy.temp.1 < %proxy.temp.2) goto start.2
  }
}
alias proxy.credits dialog -mdo proxy.credits proxy.credits
alias proxy.update.tab4 {
  if ($dialog(proxy) == $null) return
  did -r proxy 33
  did -r proxy 36
  did -a proxy 33 Active Connections ( $+ $sock(pxy*,0) $+ )
  if ($sock(pxy*,0) > 0) {
    if ($dialog(proxy) == $null) return
    if ($dialog(proxy) == $null) return
    var %proxy.temp.1 = 0
    var %proxy.temp.2 = $sock(pxy*,0)
    :start
    inc %proxy.temp.1
    did -a proxy 36 $sock(pxy*,%proxy.temp.1)
    if (%proxy.temp.1 < %proxy.temp.2) goto start
  }
}
alias proxy.error {
  if ($1)  {
    set %proxy.error $1-
    dialog -mdo proxy.error proxy.error
    halt
  }
}
alias -l proxy.set.motd {
  dialog -n proxy
  set -u0 %proxy.temp.filename $$dir="Select mOTD File" *.txt
  dialog -v proxy
  did -r proxy 15
  did -a proxy 15 $nopath(%proxy.temp.filename)
  set %proxy.settings.motd.file %proxy.temp.filename
}
alias -l proxy.update.sockstat {
  var %proxy.temp.6 = $did(36,$did(36).sel).text
  did -r proxy 40,42,44,46,48,50,52,54
  did -a proxy 40 $gsock(%proxy.temp.6,1)
  did -a proxy 42 $replace($gsock(%proxy.temp.6,3),$chr(1),$chr(46)) $+ : $+ $gsock(%proxy.temp.6,4)
  did -a proxy 44 $gsock(%proxy.temp.6,2) 
  did -a proxy 46 $duration($ssock(%proxy.temp.6))
  did -a proxy 48 $asctime($calc($ctime - $sock(%proxy.temp.6).to)) - $duration($sock(%proxy.temp.6).to)
  did -a proxy 50 $sock(%proxy.temp.6).ip
  did -a proxy 52 $sock(%proxy.temp.6).port
  did -a proxy 54 $sock(%proxy.temp.6).sent / $sock(%proxy.temp.6).rcvd (bytes)
}
alias proxy.enable {
  if ($1 == 0) { 
    sockclose proxy*
    sockclose bpxy*
    echo 4 -a *** Proxy shut down.
    if ($sock(pxy*,0) > 0) sockwrite -n pxy* Closing Proxy...
    .timer 1 1 sockclose pxy*
    if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) Closed proxy
    halt 
  }
  if (%proxy.settings.ports != $null) {
    var %proxy.socklisten.ports = $numtok(%proxy.settings.ports,32)
    var %proxy.socklisten.ports.count 0
    :start.2
    inc %proxy.socklisten.ports.count
    if ($gettok(%proxy.settings.ports,%proxy.socklisten.ports.count,32))  .timer -m 1 1 socklisten proxy $+ $gettok(%proxy.settings.ports,%proxy.socklisten.ports.count,32) $gettok(%proxy.settings.ports,%proxy.socklisten.ports.count,32)
    if (%proxy.socklisten.ports.count < %proxy.socklisten.ports) goto start.2
    echo 3 -a *** Proxy now listening on ports %proxy.settings.ports
    if (%proxy.settings.idlekick) .timerPXY.IDLE -o 0 50 proxy.check.idle
    if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) Started proxy on ports %proxy.settings.ports
  }
}
;------ Events ------
on *:LOAD: {
  if ($version < 5.61) { echo 4 -a *** Mr Proxy 2.0 requires mIRC 5.61 or higher. Unloading... | .timer 1 1 unload -rs $script | halt }
  set %proxy.settings.guest 0
  set %proxy.settings.ping 1
  echo 3 -a *** Mr Proxy 2.0 has been loaded! You can access it using your menubar and status popups.
}
on *:START: {
  if (%proxy.settings.enable) .timer 1 1 proxy.enable
  if ($group(#proxy.identserver)) socklisten iaB 113
  if (%proxy.settings.idlekick) .timerPXY.IDLE -o 0 50 proxy.check.idle
}
on *:SOCKLISTEN:proxy*: {
  var %proxy.socklisten = pxy $+ $ticks $+ $rand(100,999)
  sockaccept %proxy.socklisten
  if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) Accepted connection from $sock(%proxy.socklisten).ip on port $remove($sockname,proxy)
  if (%proxy.settings.motd) && ($exists(%proxy.settings.motd.file)) {
    var %proxy.socklisten.lines = $lines(%proxy.settings.motd.file)
    var %proxy.socklisten.count = 0
    :start
    inc %proxy.socklisten.count
    sockwrite -n %proxy.socklisten $read -l [ $+ [ %proxy.socklisten.count ] ] %proxy.settings.motd.file
    if (%proxy.socklisten.count < %proxy.socklisten.lines) goto start
  }
  echo 3 -a *** Accepted connection to proxy (port $remove($sockname,proxy) $+ ) from $sock(%proxy.socklisten).ip
  sockwrite -n %proxy.socklisten  
  sockwrite -n %proxy.socklisten  * * * Mr Proxy 2.0 * * *
  sockwrite -n %proxy.socklisten By Pasmal <pasmal@zaz.net>
  sockwrite -n %proxy.socklisten  http://helpdesk.zaz.net/
  sockwrite -n %proxy.socklisten  
  if (%proxy.settings.guest == 0) sockwrite -n %proxy.socklisten Please logon by typing: /logon username password
  sockmark %proxy.socklisten 0.0.0.0.0. $+ $ctime
  if ($timer(PXY.IDLE) == $null) && (%proxy.settings.idlekick) .timerPXY.IDLE -o 0 50 proxy.check.idle
  proxy.update.tab4
}
on *:SOCKCLOSE:pxy*: {
  proxy.update.tab4 
}
on *:SOCKREAD:pxy*: {
  sockread %proxy.sockread
  tokenize 32 %proxy.sockread
  if (:* !iswm $1) rsock $sockname 6 $ctime
  if ($gsock($sockname,5) == b) {
    var %proxy.temp.bpxy = b [ $+ [ $sockname ] ]
    if ($sock(%proxy.temp.bpxy)) { sockwrite -n %proxy.temp.bpxy $1- | halt }
    sockwrite -n $sockname Not connected to host server! Please reconnect to the Proxy and try again.
  }
  if ($gsock($sockname,5) != b) {
    if ($1 == nick) {
      rsock $sockname 2 $2
      if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) $sock($sockname).ip wishes to be known as $2
    }
    if ($1 == user) { 
      if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) $sock($sockname).ip ( $+ $gsock($sockname,2) $+ ) user info: $2-
      set -u300 %proxy.temp.sock. [ $+ [ $sockname ] ] $2-
      if (%proxy.settings.guest == 1) {
        rsock $sockname 5 a
        rsock $sockname 1 Guest
        if (%proxy.settings.connect) { proxy.connect $sockname %proxy.settings.connect.server | halt }
        sockwrite -n $sockname Type /connect <server> <port> to connect to a server.
      }
    }
    if ($1 == logon) && ($gsock($sockname,5) !isletter) {
      if ($readini $scriptdirproxy.dat userlist $2 === $3-) {
        rsock $sockname 5 a
        rsock $sockname 1 $2
        sockwrite -n $sockname Password accepted, welcome aboard.
        if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) $sock($sockname).ip ( $+ $2 $+ ) logged in
        if (%proxy.settings.connect) { proxy.connect $sockname %proxy.settings.connect.server | halt }
        sockwrite -n $sockname Type /connect <server> <port> to connect to a server.
        halt
      }
      rsock $sockname 5 $calc($gsock($sockname,5) + 1)
      sockwrite -n $sockname Incorrect... this is your $ord($gsock($sockname,5)) attempt.
      if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) Failed logon attempt ( $+ $ord($gsock($sockname,5)) $+ ) by $sock($sockname).ip
      if ($gsock($sockname,5) >= %proxy.settings.limit.number) && (%proxy.settings.limit == 1) {
        sockwrite -n $sockname Logon failure, disconnecting... 
        if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) Disconnected $sock($sockname).ip ( $+ $gsock($sockname,2) $+ ) - reached logon attempt limit.
        .timer 1 1 sockclose $sockname
      }
    }
    if ($1 == connect) && ($2 != $Null) {
      if ($gsock($sockname,5) != a) { sockwrite -n $sockname Logon first! | halt }
      proxy.connect $sockname $2- | rsock $sockname 5 1 
    }
  }
}
;bpxy connections
on *:SOCKOPEN:bpxy*: {
  if ($sockerr > 0) { sockwrite -n $right($sockname,-1) Error connecting! | return }
  if ($timer(PXY.IDLE) == $null) && (%proxy.settings.idlekick) .timerPXY.IDLE -o 0 50 proxy.check.idle
  rsock $right($sockname,-1) 5 b
  sockwrite -n $right($sockname,-1) You are now connected...
  if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) Server side connection for $gsock($right($sockname,-1),1) ( $+ $gsock($right($sockname,-1),2) $+ ) opened: $sock($sockname).ip
  sockwrite -n $sockname NICK $gsock($right($sockname,-1),2)
  sockwrite -n $sockname USER %proxy.temp.sock. [ $+ [ $right($sockname,-1) ] ]
  unset %proxy.temp.sock. [ $+ [ $right($sockname,-1) ] ]
}
on *:SOCKREAD:bpxy*: {
  sockread %proxy.bpxy.sockread
  tokenize 32 %proxy.bpxy.sockread
  if ($2 == nick) && ($right($gettok($1,1,33),-1) == $gsock($right($sockname,-1),2)) rsock $right($sockname,-1) 2 $right($3,-1)
  if ($2 == 433) { var %proxy.temp.nick = asdf $+ $ticks |  sockwrite -n $sockname NICK %proxy.temp.nick | rsock $right($sockname,-1) 2 %proxy.temp.nick }
  if (%proxy.settings.ping == 1) && ($1 == PING) sockwrite -n $sockname PONG $2-
  if ($sockerr > 0) { sockwrite -n $right($sockname,-1) An error occured ( $+ $sockerr $+ ) | halt }
  if ($1 != $null) && ($sock($right($sockname,-1)) != $null) && ($sock($right($sockname,-1)).sq < 16384) sockwrite -n $right($sockname,-1) $1-
}
on *:SOCKCLOSE:bpxy*: {
  if ($sock($right($sockname,-1)) != $Null) sockwrite -n $right($sockname,-1) Connection from server closed!
  if (%proxy.settings.log) write $logdirproxy.log $chr(91) $+ $fulldate $+ $chr(93) Server side connection for $gsock($right($sockname,-1),1) has been closed
}
;------ Dialog Tables ------
dialog proxy.error {
  title "ERROR"
  size -1 -1 170 40
  option dbu
  button "Doh!",1,130 5 40 45, ok
  box "Error:",2, 5 5 2 45
  text "",3, 12 13 115 35
}
dialog proxy.help {
  title "Proxy QuickHelp"
  size -1 -1 170 65
  option dbu
  button "OH!",1,130 5 40 70, ok
  box "Help:",2, 5 5 2 70
  text "",3, 12 13 115 60
}
dialog proxy {
  title "Mr Proxy 2.0 - Pasmal <pasmal@zaz.net> http://helpdesk.zaz.net/"
  size -1 -1 280 175
  option dbu
  button "&?",200, 260 20 10 10
  tab "Settings",2, 1 1 280 180
  tab "User List",3
  tab "Connections",4
  tab "Help",5

  button "Done",110,205 160 70 20, ok tab 2
  button "Done",111,205 160 70 20, cancel tab 3
  button "Done",112,205 160 70 20, tab 4

  check "&Enable Proxy on port(s)",6, 10 20 64 10, tab 2
  box "",7, 10 30 260 4, tab 2
  edit "",8, 75 20 30 10, autohs tab 2
  text "(seperate each port with a space)",9,110 22 80 10, tab 2

  check "Allow &Guest Connections",10, 10 38 70 10, tab 2
  check "Reply to Server &Pings",11,10 48 70 10, tab 2
  check "&Limit Logon Attempts to",12,10 58 64 10, tab 2
  combo 13,76 58 25 90, drop tab 2
  check "&Display mOTD",14,10 70 50 10, tab 2
  button "no mOTD file &selected",15,60 72 60 8, tab 2
  text "Once logged in, connect user to...",16,10 85 90 10, tab 2
  radio "&Pre-Selected server:",17, 20 95 57 10, group tab 2
  edit "",18,81 95 50 10, autohs tab 2
  radio "Users &Choice",19, 20 105 45 10, tab 2
  check "Disconnect user if he is idle for longer than",20,10 115 110 10, tab 2
  combo 21, 122 115 40 90, drop tab 2
  check "Log Connect Attempts",212,10 125 65 10, tab 2
  check "Run IdentD Server with ident",213,10 135 80 10, tab 2
  edit "",214,90 135 40 9, autohs tab 2
  button "View",215, 75 125 40 8, tab 2

  text "User List Editor",22,10 22 60 10, tab 3
  box "",23,10 30 260 4, tab 3
  combo 24,10 40 100 140, sort tab 3
  button "&Save User",25,160 88 50 12, tab 3
  button "&Del User",26,115 40 30 12, tab 3
  button "Refresh",57,115 55 30 12, tab 3
  text "Cre&ate/Modify User:",27,160 40 60 10, tab 3
  edit "",28,160 50 50 10, autohs tab 3
  text "Password",29,160 64 50 10, tab 3
  edit "",30, 160 74 50 10, pass autohs tab 3
  box "",31, 150 30 1 145, tab 3
  text "Note: passwords are case sensitive. This means you must type the password using the correct case (e.g. upper or lower).",32,215 50 50 50, tab 3

  text "Active Connections",33, 10 22 60 10, tab 4
  box "",34,10 30 260 4, tab 4
  text "Name:",35,10 40 40 10, tab 4
  list 36,10 50 60 130, vsbar tab 4
  box "",37,75 30 1 145, tab 4
  text "Details:",38,85 40 40 10, tab 4
  text "Username:",39,85 51 25 10, tab 4
  edit "",40,125 50 60 9, read autohs tab 4
  text "Connected to:",41, 85 61 35 10, tab 4
  edit "",42,125 60 60 9, read autohs tab 4
  text "Nickname:",43, 85 71 35 10, tab 4
  edit "",44,125 70 60 9, read autohs tab 4
  text "Idle:",45, 85 81 35 10, tab 4
  edit "",46,125 80 60 9, read autohs tab 4
  text "Online Since:",47, 85 91 35 10, tab 4
  edit "",48, 125 90 60 9, read autohs tab 4
  text "IP:",49,85 101 35 10, tab 4
  edit "",50, 125 100 60 9, read autohs tab 4
  text "Local Port:",51,85 111 60 10, tab 4
  edit "",52, 125 110 60 9, read autohs tab 4
  text "Data Sent/Rcvd:",53, 85 121 35 15, tab 4
  edit "",54,125 125 60 9, read autohs tab 4
  button "Update",55, 190 50 50 15, tab 4
  button "Disconnect",56, 190 70 50 15, tab 4

  text "Help",58,10 22 30 10, tab 5
  box "",59,10 30 265 4, tab 5
  edit "",60, 10 40 265 140, multi read vsbar hsbar tab 5
  button "About Mr Proxy 2.0",61,210 18 60 11, default tab 5
}
dialog proxy.credits {
  title "About Mr Proxy 2.0"
  size -1 -1 340 80
  button "done",1,350 1 1 1, ok
  box "About",2, 5 5 4 70
  text "Created by Pasmal <pasmal@zaz.net> for #HelpDesk on DALnet",3,20 20 340 20
  text "/server irc.dal.net 7000   http://helpdesk.zaz.net/",4,20 45 185 30
  icon 5,  245 40 88 31, hd.bmp
}
; ----- Dialog Events ------
on *:DIALOG:proxy.help:init:0: did -a proxy.help 3 %proxy.help.text
on *:DIALOG:proxy.error:init:0: did -a proxy.error 3 %proxy.error
on *:DIALOG:proxy:init:0: {
  set %proxy.last.tab 2
  var %proxy.init.1 = 0
  :start
  inc %proxy.init.1 
  did -a proxy 13 %proxy.init.1
  if (%proxy.init.1 < 10) goto start
  did -a proxy 21 1 minute $str($chr(160),25) $chr(1) $+ 60.1
  did -a proxy 21 2 minutes $str($chr(160),25) $chr(1) $+ 120.2
  did -a proxy 21 5 minutes $str($chr(160),25) $chr(1) $+ 300.3
  did -a proxy 21 10 minutes $str($chr(160),25) $chr(1) $+ 600.4
  did -a proxy 21 20 minutes $str($chr(160),25) $chr(1) $+ 1200.5
  did -a proxy 21 30 minutes $str($chr(160),25) $chr(1) $+ 1800.6
  did -a proxy 21 45 minutes $str($chr(160),25) $chr(1) $+ 2700.7
  did -a proxy 21 1 hour $str($chr(160),25) $chr(1) $+ 36000.8
  did -a proxy 21 2 hours $str($chr(160),25) $chr(1) $+ 7200.9
  did -a proxy 21 5 hours $str($chr(160),25) $chr(1) $+ 18000.10
  did -a proxy 21 10 hours $str($chr(160),25) $chr(1) $+ 36000.11
  proxy.update.tab2
}
alias -l proxy.help {
  set %proxy.help.text $readini $scriptdirproxy-qhelp.ini item $1
  if (%proxy.help.text == $null) set %proxy.help.text No Help for this Topic ( $+ $did $+ ) found!
  dialog -mdo proxy.help proxy.help

}
on *:DIALOG:proxy:sclick:*: {
  if (%proxy.help.log) {
    ;Done buttons.
    if ($istok(110 111 113,$did,32)) .timer -m 1 1 proxy.help Done
    ;checkboxes
    if ($istok(6 10 11 12 14 20 212 213,$did,32)) {
      if ($did($did).state == 1) { did -u proxy $did } | { else did -c proxy $did }
      .timer -m 1 1 proxy.help $did
    }
    ;tabs
    if ($istok(2 3 4 5,$did,32)) { .timer -m 1 1 proxy.help $did | did -f proxy %proxy.last.tab }
    ;radios
    if ($istok(17 19,$did,32)) { .timer -m 1 1 proxy.help $did | if (%proxy.settings.connect) { did -c proxy 17 | did -u proxy 19 } | else { did -c proxy 19 | did -u proxy 17 } }
    ;buttons
    if ($istok(15 215 25 26 55 56 57 61,$did,32)) .timer -m 1 1 proxy.help $did
    if ($did == 200) .timer -m 1 1 proxy.help help
    unset %proxy.help.log
    halt
  }
  if ($istok(2 3 4 5,$did,32)) {
    set %proxy.last.tab $did
    if ($did != 5) did -v proxy 200
  }
  if ($did == 200) { 
    set %proxy.help.log 1
    halt
  }
  if ($did == 4) proxy.update.tab4
  if ($did == 3) proxy.retype.userlist
  if ($did == 26) {
    if ($did(proxy,24,$did(proxy,24).sel).text == $null) { proxy.error A username must be selected first! Click in the editbox below "Username:" and type in a username, or select a username from the combo to its left. For more help click on the Help tab. | halt }
    remini $scriptdirproxy.dat userlist $did(proxy,24,$did(proxy,24).sel).text
    did -d proxy 24 $did(proxy,24).sel
    saveini $scriptdirproxy.dat
  }
  if ($did == 112) && ($dialog(proxy)) dialog -x proxy
  if ($did == 215) && ($isfile($logdirproxy.log)) run notepad $logdirproxy.log
  if ($did == 55) {
    if ($did(36).sel == $null) { .timer -m 1 1 proxy.error You first need to select a name in the list to your right. Once you have done this you can use the Update button. For more help click on the Help tab. | halt }
    proxy.update.sockstat
  }
  if ($did == 24) {
    did -r proxy 28,30
    did -a proxy 28 $did(proxy,24,$did(proxy,24).sel).text
    did -a proxy 30 $readini -n $scriptdirproxy.dat userlist $did(proxy,24,$did(proxy,24).sel).text
  }
  if ($did == 56) {
    if ($did(36,$did(36).sel).text == $null) { .timer -m 1 1 proxy.error You must select a connection to disconnect first! You can do this by clicking on a name in the listbox under "Name:" then hitting this button again (disconnect). For more help click on the Help tab. | halt }
    if ($sock($did(36,$did(36).sel).text) == $null) { proxy.update.tab4 | .timer -m 1 1 proxy.error Since I last checked this connection has already been killed. The connections list has already been refreshed. For more help click on the Help tab. | halt }
    sockwrite -n $did(36,$did(36).sel).text Disconnecting you...
    .timer 1 1 sockclose $did(36,$did(36).sel).text
    .timer -o 1 1.2 proxy.update.tab4
  }
  if ($did == 57) proxy.retype.userlist
  if ($did == 25) {
    if ($did(28).text == $null) || ($did(30).text == $null) { proxy.error Not Enough Parameters! Make sure you entered both a username and a password! For more help click on the Help tab. | halt }
    writeini $scriptdirproxy.dat userlist $did(28).text $did(30).text
    saveini $scriptdirproxy.dat
    did -r proxy 25
    did -a proxy 25 DONE!
    .timer 1 1 did -r proxy 25
    .timer 1 1.1 did -a proxy 25 Save User
    proxy.retype.userlist
  }
  if ($did == 2) {
    proxy.update.tab2
  }
  if ($dialog($dname).tab == 4) {
    if ($did == 36) proxy.update.sockstat
  }
  if ($did == 61) .timer -m 1 1 proxy.credits
  if ($did == 5) && ($isfile(proxy-help.txt)) { did -h proxy 200 | did -r proxy 60 | loadbuf -o proxy 60 proxy-help.txt }
  if ($dialog($dname).tab == 2) {
    if ($did == 6) { set %proxy.settings.enable $did($did).state | proxy.enable $did($did).state }
    if ($did == 10) set %proxy.settings.guest $did($did).state
    if ($did == 11) set %proxy.settings.ping $did($did).state
    if ($did == 12) set %proxy.settings.limit $did($did).state
    if ($did == 13) set %proxy.settings.limit.number $did($did).sel
    if ($did == 14) set %proxy.settings.motd $did($did).state
    if ($did == 15) .timer -m 1 1 proxy.set.motd
    if ($did == 17) set %proxy.settings.connect 1
    if ($did == 19) set %proxy.settings.connect 0
    if ($did == 20) { set %proxy.settings.idlekick $did($did).state | .timerPXY.IDLE $iif($did(20).state == 1,-o 0 50 proxy.check.idle,off) }
    if ($did == 21) { set %proxy.settings.idlekick.duration $gettok($gettok($did(21,$did(21).sel).text,2,1),1,46) | set %proxy.settings.idlekick.cline $gettok($gettok($did(21,$did(21).sel).text,2,1),2,46) }
    if ($did == 212) set %proxy.settings.log $did($did).state
    if ($did == 213) {
      if ($did($did).state == 1) && ($sock(iaB) == $null) && ($portfree(113) == $true) socklisten iaB 113 
      $iif($did($did).state == 1,.enable,.disable) #proxy.identserver
    }
  }
}
on *:DIALOG:proxy:edit:*: {
  if ($did == 18) {
    if ($did(18).text) { set %proxy.settings.connect.server $did(18).text | halt }
    unset %proxy.settings.connect.server
  }
  if ($did == 8) {
    if ($did(8).text) { set %proxy.settings.ports $did(8).text | halt }
    unset %proxy.settings.ports
  }
  if ($did == 214) {
    if ($did(214).text) { set %proxy.settings.identd $did(214).text | halt }
    unset %proxy.settings.identd
  }
}
on *:DIALOG:proxy.credits:sclick:5: if (http://helpdesk.zaz.net/* !iswm $url) run http://helpdesk.zaz.net/
#proxy.identserver on
on *:SOCKREAD:ident*: {
  sockread %ident
  if (%ident) {
    sockwrite -n $sockname  $gettok(%ident,1,32) $+ , 6667 : USERID : UNIX : %proxy.settings.identd
    echo 4 -a *** Replied to IDENTD request from $sock($sockname).ip $+ : $gettok(%ident,1,32) $+ , 6667 : USERID : UNIX : %proxy.settings.identd
    if ($sock(iaB) == $null) socklisten iaB 113
  }
}
on *:SOCKLISTEN:iaB: sockaccept ident [ $+ [ $ticks ] ] | echo 4 -a *** Accepted an IDENTD connection request...
on *:SOCKCLOSE:ident*: echo 4 -a *** Closed an IDENTD connection from $sock($sockname).ip $+ .
#proxy.identserver end
